import java.io.IOException;
import java.io.PrintWriter;
import java.util.Objects;

import javax.annotation.processing.ProcessingEnvironment;
import javax.tools.FileObject;
import javax.tools.JavaFileObject;
import javax.tools.StandardLocation;

final class FileOperations {

	static final FileOperations FILE_OPERATIONS = new FileOperations();

	private FileOperations() {
	}

	void write(final ProcessingEnvironment processingEnv, final String testClassName, final String contents) {
		try {
			final FileObject fileObject = processingEnv.getFiler().getResource(StandardLocation.SOURCE_OUTPUT, "",
					testClassName + ".java");
			
			if (!Objects.isNull(fileObject)) {
				final JavaFileObject testClassFile = processingEnv.getFiler().createSourceFile(testClassName);
				try (PrintWriter out = new PrintWriter(testClassFile.openWriter())) {
					out.write(contents);
				}
			}
		} catch (IOException e) {
			throw new IllegalStateException("Unable to create test class", e);
		}
	}
}
